;
; Mode 6/7 test
;
; This code is free to use, rip apart, sell, marry, rub some cheese into...
;
                opt     Z80                                     ; Set Z80 mode
                opt     ZXNEXTREG                               ; enable NextReg instruction


                seg     CODE_SEG, 4:$0000,$8000                 ; flat address
                seg     ULA_SEG, 10:$0000,$4000                 ; ULA "bank" (for Tilemaps)
                seg     LAYER2_SEG, 18:$0000,$4000              ; Layer 2 start address (OS default starts at bank 18)
                seg     CHARSET_SEG, 24:$0000,$8000             ; ZX Font
                seg     TESTCOED_SEG, 50:$0000,$c000            ; long call test

                include "includes.asm"
  
  


                seg     CODE_SEG

;Starter			db	1


; 11 frames
;Starter2
		; frame 0
                db	24,25		; banks
                ;dw	$c000	
StackEnd:
                ds      127
StackStart:     db      0



; *****************************************************************************************************************************
; Start of game code
; *****************************************************************************************************************************
StartAddress:
                di

                ; because we don't kill the ROM or take over the interrupts, it modifies 
                ; FRAMES sys variable, so we'll just over write it each frame...what the hell.
                ld      a,($5c78)
                ld      (hack),a
                ld      a,($5c79)
                ld      (hack+1),a
                ld      a,($5c7a)
                ld      (hack+2),a

                ei
                NextReg 128,0                   ; Make sure expansion bus is off.....
                NextReg $07,3                   ; 3.5Mhz
                NextReg $05,4
				;NextReg $12,9

                ld      a,0
                out     ($fe),a

                call    BitmapOn
                call    InitSprites

                ld      a,0                     ; black boarder
                out     ($fe),a


                ld      a,%001000
                ld      bc,$7ffd
                out     (c),a

                NextReg $14,$e7                 ; set transparent colour

                ; fill Shadow screen ULA attribute screen with ink 7, paper 3
                NextReg $57,14                  ; MMU7 to shadow screen
                ld      a,%00011111             ; paper 3, ink 7, bright
                ld      hl,$e000+6144
                ld      (hl),a
                ld      de,$e001+6144
                ld      bc,768

                ldir

                call    InitMap

         
; ----------------------------------------------------------------------------------------------------
;               Main loop
; ----------------------------------------------------------------------------------------------------
MainLoop:
                halt

                ld      a,(hack)                ; restore data over the top of FRAMES system variable
                ld      ($5c78),a
                ld      a,(hack+1)
                ld      ($5c79),a
                ld      a,(hack+2)
                ld      ($5c7a),a

                ;ld      a,7
                ;out     ($fe),a
                ;ld      bc,$fe
                ;in      a,(c)

                call    ReadKeyboard

                ; copy in scroll values to copper

				NextReg	$56,50
				call	LongCall
				NextReg	$56,2


				; Pick mode 6
				ld		a,(Keys+VK_6)
				and		a
				jr		z,NotPressed6
				ld		a,(reg_15)
				and		%11100011
				or		%00011000
				ld		(reg_15),a
				NextReg	$15,a
				xor		a
				ld		(Keys+VK_6),a
NotPressed6:
				; Pick mode 7
				ld		a,(Keys+VK_7)
				and		a
				jr		z,NotPressed7
				ld		a,(reg_15)
				and		%11100011
				or		%00011100
				ld		(reg_15),a
				NextReg	$15,a
				xor		a
				ld		(Keys+VK_7),a
NotPressed7:


				; Tiles always on top
				ld		a,(Keys+VK_R)
				and		a
				jr		z,NotPressedR
				ld		a,(reg_6b)
				xor		1
				ld		(reg_6b),a
				NextReg	$6b,a
				xor		a
				ld		(Keys+VK_R),a
NotPressedR:
				; Tile attribute priority toggle
				ld		a,(Keys+VK_T)
				and		a
				jr		z,NotPressedT
				ld		a,(reg_6c)
				xor		1
				ld		(reg_6c),a
				NextReg	$6c,a
				call	ToggleTilePri
				xor		a
				ld		(Keys+VK_T),a
NotPressedT:


				; Scroll tiles left/right
				ld		a,(Keys+VK_P)
				and		a
				jr		z,NotPressedP
				ld		hl,(TilesX)
				dec		hl
				ld		a,h
				and		3
				ld		h,a				
				ld		(TilesX),hl
				xor		a
				ld		(Keys+VK_P),a
NotPressedP:
				ld		a,(Keys+VK_O)
				and		a
				jr		z,NotPressedO
				ld		hl,(TilesX)
				inc		hl
				ld		a,h
				and		3
				ld		h,a				
				ld		(TilesX),hl				
				xor		a
				ld		(Keys+VK_O),a
NotPressedO:
				ld		a,(TilesX)
				NextReg	$30,a
				ld		a,(TilesX+1)
				NextReg	$2f,a



				; Scroll tiles up/down
				ld		a,(Keys+VK_A)
				and		a
				jr		z,NotPressedA
				ld		a,(TilesY)
				dec		a
				ld		(TilesY),a
				xor		a
				ld		(Keys+VK_A),a
NotPressedA:
				ld		a,(Keys+VK_Q)
				and		a
				jr		z,NotPressedQ
				ld		a,(TilesY)
				inc		a
				ld		(TilesY),a
				xor		a
				ld		(Keys+VK_Q),a
NotPressedQ:
				ld		a,(TilesY)
				NextReg	$31,a

				; Blend modes - Z,X,C,V
				ld		a,(Keys+VK_Z)
				and		a
				jr		z,NotPressedZ
				ld		a,(reg_68)
				and		%10011111
				or		%00000000
				ld		(reg_68),a
				NextReg	$68,a
				xor		a
				ld		(Keys+VK_Z),a
NotPressedZ:
				ld		a,(Keys+VK_X)
				and		a
				jr		z,NotPressedX
				ld		a,(reg_68)
				and		%10011111
				or		%01000000
				ld		(reg_68),a
				NextReg	$68,a
				xor		a
				ld		(Keys+VK_X),a
NotPressedX:
				ld		a,(Keys+VK_C)
				and		a
				jr		z,NotPressedC
				ld		a,(reg_68)
				and		%10011111
				or		%01100000
				ld		(reg_68),a
				NextReg	$68,a
				xor		a
				ld		(Keys+VK_V),a
NotPressedC:
				ld		a,(Keys+VK_V)
				and		a
				jr		z,NotPressedV
				ld		a,(reg_68)
				and		%10011111
				or		%00100000
				ld		(reg_68),a
				NextReg	$68,a
				xor		a
				ld		(Keys+VK_V),a
NotPressedV:




;				ld		a,(Keys+VK_R)
;				and		a
;				jr		z,NotPressed
;
;HANG:			NextReg	2,2
;				xor		a
;				ld		(Keys+VK_R),a
;NotPressed:
                ;ld      a,0
                ;out     ($fe),a


				NextReg	$56,14
				ld		a,(reg_6b)
				ld		de,$d800-(2048+32)
				call	PrintHex

				ld		a,(reg_6c)
				ld		de,$d800-(2048+29)
				call	PrintHex

				ld		a,(TilesX+1)
				ld		de,$d800-(2048+26)
				call	PrintHex

				ld		a,(TilesX)
				ld		de,$d800-(2048+24)
				call	PrintHex

				ld		a,(TilesY)
				ld		de,$d800-(2048+21)
				call	PrintHex

                jp      MainLoop

reg_15			db		%00011001
reg_68			db		%00100000
reg_6b			db		%10000000
reg_6c			db		0
TilesX		    dw		0
TilesY		    db		0
hack			db		0,0,0,0


; *****************************************************************************************************************************
; includes modules
; *****************************************************************************************************************************
                include "scroll.asm"
                include "utils.asm"
                
				nop
				include "spritehandler.asm"
				nop


; *****************************************************************************************************************************
; Data
; *****************************************************************************************************************************
TilePalette:    incbin  "tiles.pal"

                seg     ULA_SEG
Tiles:          incbin  "tiles.tiles"		
                org $7600
Tilemap:        incbin  "tiles.tilemap"		

                seg     LAYER2_SEG
                incbin  "beastf.256"		; use the beast L2 background for testing
                
                seg     CHARSET_SEG
                incbin  "charset.dat"		; ZX rom FONT, as the NEXT rom doesn't have the font available to us


				seg		TESTCOED_SEG
LongCall:
				ld		a,0
				ld		hl,$1234
				ret

                savenex "TileTest.nex",StartAddress,StackStart        





